/*
 * Game & Watch Volleyball, an "Arcade Volleyball" clone with reworked Game & Watch
 * sprites based upon an early version of "Volleyball", originally coded by Hugo Ruscitti
 * You may check Hugo's web site for more info: http://www.loosersjuegos.com.ar
 * Game & Watch Volleyball is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * Game & Watch Volleyball is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 * 
 */

#ifndef _JUEGO_H
#define _JUEGO_H

#include <stdlib.h>
#include <SDL.h>
#include "dirty.h"
#include "pelota.h"
#include "personaje.h"
#include "puntaje.h"

static int dosJugadores, cambioFondo;

#define GP2X_UP              0
#define GP2X_DOWN            4
#define GP2X_LEFT            2
#define GP2X_RIGHT           6
#define GP2X_CLICK           18
#define GP2X_A               12
#define GP2X_B               13
#define GP2X_X               15
#define GP2X_Y               14
#define GP2X_L               10
#define GP2X_R               11
#define GP2X_START           8
#define GP2X_SELECT          9
#define GP2X_VOLUP           16
#define GP2X_VOLDOWN         17

typedef struct Juego
{
	Pelota * pelota;
	Dirty * dirty;
	Personaje * personaje_1;
	Personaje * personaje_2;
	Puntaje * puntaje;
	SDL_Surface * fondo;
	SDL_Surface * screen;
	SDL_Joystick* joy;
} Juego;

int juego_iniciar (Juego * juego);
int juego_cargar_fondo (Juego * juego);
void juego_cambiar_fondo(Juego * juego);
int juego_iniciar_procesos (Juego * juego);
void juego_ciclo_logico (Juego * juego);
void juego_ciclo_grafico (Juego * juego);
void juego_terminar (Juego * juego);
void juego_dosJugadores(Juego* juego);
void juego_cambioFlag();

#endif
