/*
 * Game & Watch Volleyball, an "Arcade Volleyball" clone with reworked Game & Watch
 * sprites based upon an early version of "Volleyball", originally coded by Hugo Ruscitti
 * You may check Hugo's web site for more info: http://www.loosersjuegos.com.ar
 * Game & Watch Volleyball is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * Game & Watch Volleyball is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 * 
 */
 
#include <string.h>
#include <stdlib.h>
#include "sonido.h"

static int volumen;

int abrirAudio()
{
	if (SDL_InitSubSystem(SDL_INIT_AUDIO) == -1 || Mix_OpenAudio(22050, AUDIO_S16, 1, 128) <0)
		{
			return 1;
		}
		
		sonidos[SND_ANDAR] = Mix_LoadWAV("data/andar.wav");
		sonidos[SND_FALLO] = Mix_LoadWAV("data/fallo.wav");
		sonidos[SND_FINTIEMPO] = Mix_LoadWAV("data/fintiempo.wav");
		sonidos[SND_CABEZAZO] = Mix_LoadWAV("data/cabezazo.wav");
		sonidos[SND_TRES] = Mix_LoadWAV("data/fallo2.wav");
		sonidos[SND_COMIENZO] = Mix_LoadWAV("data/comienzo.wav");
		volumen = 40;
		Mix_Volume(-1,volumen);

	return 0;
}


int cerrarAudio()
{
	Mix_FreeChunk(sonidos[SND_ANDAR]);
	Mix_FreeChunk(sonidos[SND_FALLO]);
	Mix_FreeChunk(sonidos[SND_FINTIEMPO]);
	Mix_FreeChunk(sonidos[SND_CABEZAZO]);
	Mix_CloseAudio();
	return 0;
} 

void reproducirSonido(int soundCode)
{
	Mix_PlayChannel(1, sonidos[soundCode], 0);
}

void aumentarVolumen()
{
	if (volumen < 120) 
	{
		volumen = volumen + 40;
		Mix_Volume(-1,volumen);
	}
	else 
	{
		volumen = 120;
		Mix_Volume(-1,volumen);
	} 
}

void reducirVolumen()
{
	if (volumen > 11) 
	{
		volumen = volumen - 40;
		Mix_Volume(-1,volumen);
	}
	else 
	{	
		volumen = 0;
		Mix_Volume(-1,volumen);
	} 
}



