/*
 * Game & Watch Volleyball, an "Arcade Volleyball" clone with reworked Game & Watch
 * sprites based upon an early version of "Volleyball", originally coded by Hugo Ruscitti
 * You may check Hugo's web site for more info: http://www.loosersjuegos.com.ar
 * Game & Watch Volleyball is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * Game & Watch Volleyball is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 * 
 */

#include <SDL.h>
#include "util.h"
#include "fps.h"
#include "juego.h"
#include "sonido.h"
#include "sistema.h"


int main (int argc, char * argv [])
{
	
	gp2x_ram_init();
	gp2x_set_cpu_speed (120);
  	disable_940();
	struct Juego juego;
	int repeticiones;
	int i;

	if (iniciar_sdl (& juego.screen, &juego.joy))
		return 1;

	if (juego_iniciar (& juego))
		   return 1;
	
	Mix_Volume(-1,80);
	reproducirSonido(SND_COMIENZO);

	while (procesar_eventos ())
	{
		repeticiones = fps_sincronizar ();

		for (i = 0; i < repeticiones; i ++)
			juego_ciclo_logico (& juego);
		
		juego_ciclo_grafico (& juego);
		
		// Tenemos un ganador?
		if ((juego.puntaje->puntos_p1 == 15) || (juego.puntaje->puntos_p2 == 15)) 
		{
			reproducirSonido(SND_FINTIEMPO);
			juego_iniciar_procesos(&juego);
		}
		
		
	}

	juego_terminar (& juego);
	
	SDL_Quit ();
    chdir("/usr/gp2x");
    execl("/usr/gp2x/gp2xmenu", "/usr/gp2x/gp2xmenu", NULL);
	
	return 0;
}
